#include "Stdafx.h"

#define WIN_TOOLS_PATH  L"\\\\10.4.0.102\\MSWG2\\download\\win-tools\\"
#define PYTHON_PATH     L"\\\\10.4.0.102\\mswg\\win\\Packages\\Regression\\python_install\\"
#define REGRESSION_PATH L"\\\\10.4.0.102\\mswg\\win\\Packages\\Regression\\"


CInstall::CInstall(MachineArch Arch, OsVersion OsVer)
{
    m_Arch = Arch;
    m_OsVer = OsVer;
}

bool
CInstall::DoInstall()
{
    bool bRet;
    
    wprintf(L"===>NetUseDrivers\n");
    bRet = NetUseDrivers();
    if(bRet == false)
    {
        return false;
    }

    wprintf(L"===>Windbg\n");
    bRet = Windbg();
    if(bRet == false)
    {
        return false;
    }

    wprintf(L"===>Tsvn\n");    
    bRet = Tsvn();
    if(bRet == false)
    {
        return false;
    }
    
    wprintf(L"===>Perl\n");    
    bRet = Perl();
    if(bRet == false)
    {
        return false;
    }   

    return true;
}

//
//
//
bool
CInstall::ForRegression()
{
    
    bool bRet;
    
    wprintf(L"===>ShutdownEventTracker\n");        
    bRet = ShutdownEventTracker();
    if(bRet == false)
    {
        return false;
    }

    wprintf(L"===>RunPlayer\n");             
    bRet = RunPlayer();
    if(bRet == false)
    {
        return false;
    }


    wprintf(L"===>RunPlayer2\n");    
    bRet = RunPlayer2();
    if(bRet == false)
    {
        return false;
    }


    wprintf(L"===>StartUpDeamon\n");        
    bRet = StartUpDeamon();
    if(bRet == false)
    {
        return false;
    }

    wprintf(L"===>CopyShutdown\n");        
    bRet = CopyShutdown();
    if(bRet == false)
    {
        return false;
    }


    wprintf(L"===>MakeTmpDir\n");        
    bRet = MakeTmpDir();
    if(bRet == false)
    {
        return false;
    }

    return true;
}


bool
CInstall::NetUseDrivers()
{
    int retVal;
        
    CComBSTR bstrCmd = L"start cmd /c net use s: \\\\10.4.0.130\\s$ /u:ntyok.mtl.com\\herod herod11";        
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
    
    bstrCmd = L"start cmd /c net use M: \\\\labfs01\\mswg /u:ntyok.mtl.com\\herod herod11";        
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
    
    bstrCmd = L"start cmd /c net use N: \\\\labfs01\\mswg2 /u:ntyok.mtl.com\\herod herod11";        
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }

    
    bstrCmd = L"start cmd /c net use L: \\\\labfs01\\swgwork /u:ntyok.mtl.com\\herod herod11";        
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }

    return true;
}

//
//
//
bool
CInstall::Windbg()
{
    int retVal;
    CComBSTR bstrDbgPath= WIN_TOOLS_PATH;
    bstrDbgPath += L"DebuggingTools\\";

    CComBSTR bstrMsiPath = bstrDbgPath;
    if(m_Arch == x64)
    {
        bstrMsiPath += L"dbg_amd64_6.9.3.113.msi";
    }
    else if(m_Arch == X86)
    {
        bstrMsiPath += L"dbg_x86_6.9.3.113.msi";
    }

    
    CComBSTR bstrCmd = L"msiexec /i ";
    bstrCmd += bstrMsiPath;    
    bstrCmd += L" /qn /norestart ";


    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }

    bstrCmd = L"start cmd /c ";
    bstrCmd += bstrDbgPath;
    if(m_Arch == x64)
    {
        bstrCmd += L"SetDebuggerSymbols_x64.cmd";
    }
    else if(m_Arch == X86)
    {
        bstrCmd += L"SetDebuggerSymbols_x86.cmd";
    }
    

    wprintf(L"Executing command: %s\n",bstrCmd);        
    
    retVal = _wsystem(bstrCmd);    
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
            
    return true;
}


//
//
//
bool
CInstall::Tsvn()
{    
    int retVal;
    CComBSTR bstrTsvnPath= WIN_TOOLS_PATH;
    bstrTsvnPath += L"svn\\";

    CComBSTR bstrMsiPath = bstrTsvnPath;
    if(m_Arch == x64)
    {
        bstrTsvnPath += L"TortoiseSVN-1.4.3.8645-x64-svn-1.4.3.msi";
    }
    else if(m_Arch == X86)
    {
        bstrTsvnPath += L"TortoiseSVN-1.4.3.8645-win32-svn-1.4.3.msi";
    }

    
    CComBSTR bstrCmd = L"msiexec /i ";
    bstrCmd += bstrTsvnPath;
    bstrCmd += L" /qn /norestart";


    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }


    return true;
}


//
//
//
bool
CInstall::Perl()
{
    int retVal;
    CComBSTR bstrPerlPath= WIN_TOOLS_PATH;
    
    CComBSTR bstrMsiPath = bstrPerlPath;
    bstrMsiPath += L"Perl\\ActivePerl\\ActivePerl-5.8.4.810-MSWin32-x86.msi";
    
        
    CComBSTR bstrCmd = L"msiexec /i ";
    bstrCmd += bstrMsiPath;
    bstrCmd += L" /qn /norestart";
    //
    //  Install Perl
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }

    return true;
}


//
//
//
bool 
CInstall::ShutdownEventTracker()
{
    CComBSTR bstrRegPath = L"";

    if(m_OsVer == Win2003)
    {
        bstrRegPath= L"SOFTWARE\\Policies\\Microsoft\\Windows NT";    
    }
    else
    {
        bstrRegPath= L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion";    
    }
    
    HKEY hKey;
    int retVal;   
    
    retVal= RegOpenKeyEx(HKEY_LOCAL_MACHINE,bstrRegPath, 0, KEY_ALL_ACCESS , &hKey);
    if( retVal!= ERROR_SUCCESS )
    {
        wprintf(L"Faild RegOpenKeyEx \n");       
        return false;        
    }
    
    HKEY NewKey;    
    retVal = RegCreateKeyEx(hKey,
                            L"Reliability",
                            NULL,
                            NULL,
                            REG_OPTION_NON_VOLATILE,
                            KEY_WRITE,
                            NULL,
                            &NewKey,
                            NULL
                           );
    if(retVal != ERROR_SUCCESS)
    {
        wprintf(L"Faild to creat new registry key -Reliability- \n");       
        RegCloseKey( hKey) ; 
        return false;
    }
    
    RegCloseKey( hKey) ; 
    
    BYTE ZeroBuf[4]={0};                                                                     
    retVal= RegSetValueEx(NewKey,
                          L"ShutDownReasonOn",
                          0,
                          REG_DWORD,
                          ZeroBuf,
                          sizeof(ZeroBuf)
                          );   
    if( retVal!= ERROR_SUCCESS )
    {
        wprintf(L"Faild to set value to registry key -Reliability- \n");     
        return false;        
    }
    
    RegCloseKey(NewKey) ;        
    
        
    return true;
}


//
//
//
bool
CInstall::RunPlayer()
{
     int retVal;
    
    CComBSTR RunPlayerPath = REGRESSION_PATH;       
    RunPlayerPath += L"RunPlayer.py";


        
    CComBSTR bstrCmd = L"xcopy /s /i /Y ";
    bstrCmd += RunPlayerPath ;
    bstrCmd += L" \"%USERPROFILE%\\Desktop\" ";
    //
    //  Copy runplayer.py to herod desktop
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }


#if 0    
    //
    //
    // Copy runplayer.py to herod programs startup    
    bstrCmd = L"xcopy /s /i /Y ";
    bstrCmd += RunPlayerPath ;    
    bstrCmd += L" \"%SystemDrive%\\Documents and Settings\\herod\\Start Menu\\Programs\\Startup\"";    
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
#endif    


    return true;
    
}

//
//
//
bool
CInstall::RunPlayer2()
{    
    int retVal;    
    CComBSTR RunPlayerPath2 = REGRESSION_PATH;       
    RunPlayerPath2 += L"RunPlayer2.py";
        
    CComBSTR bstrCmd = L"xcopy /s /i /Y ";
    bstrCmd += RunPlayerPath2 ;

    bstrCmd += L" c:";        
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }

    if(m_OsVer == Win2008)
    {
        bstrCmd = L"xcopy /s /i /Y ";       
        bstrCmd += RunPlayerPath2;
        bstrCmd += L" d:";
        retVal = _wsystem(bstrCmd);
        if(retVal == -1)
        {
            wprintf(L"Error in executing command: %s\n",bstrCmd);        
            return false;
        }
    }
            
    return true;    
}

//
//
//
bool 
CInstall::StartUpDeamon()
{    
    int retVal;    
    CComBSTR StartUpDeamonPath = REGRESSION_PATH;       
    StartUpDeamonPath += L"startup_daemon.py";
    
    CComBSTR bstrCmd = L"xcopy /s /i /Y ";
    bstrCmd += StartUpDeamonPath ;
    bstrCmd += L" c:";                
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
    
    if(m_OsVer == Win2008)
    {
        bstrCmd = L"xcopy /s /i /Y ";       
        bstrCmd += StartUpDeamonPath;
        bstrCmd += L" d:";
        retVal = _wsystem(bstrCmd);
        if(retVal == -1)
        {
            wprintf(L"Error in executing command: %s\n",bstrCmd);        
            return false;
        }
    }
    
    return true;
}

//
//
//
bool
CInstall::CopyShutdown()
{
    if(m_Arch == x64)
    {        
        int retVal;        
        CComBSTR bstrCmd = L"xcopy /Y /h /k %SystemRoot%\\system32\\shutdown.exe %SystemRoot%\\SysWOW64\\shutdown.exe";

        wprintf(L"Executing command: %s\n",bstrCmd);
        //
        //  Copy system32\shutdown.exe to SysWOW64        
        retVal = _wsystem(bstrCmd);
        if(retVal == -1)
        {
            wprintf(L"Error in executing command: %s\n",bstrCmd);        
            return false;
        }                
    }
    
    return true;
}

//
//
//
bool
CInstall::MakeTmpDir()
{    
    int retVal;
    
    CComBSTR bstrCmd = L"mkdir  %SystemDrive%\\tmp";
    //
    //  create tmp directory on sytem drive
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
/*
    if(m_OsVer == Win2008)
    {        
        bstrCmd = L"xcopy /y  \\labfs01\\mswg2\\download\\win-tools\\MellanoxCertificate %SystemDrive%\\tmp";    
        retVal = _wsystem(bstrCmd);
        if(retVal == -1)
        {
            wprintf(L"Error in executing command: %s\n",bstrCmd);        
            return false;
        }
        
        bstrCmd =L"%SystemDrive%\\tmp\\certmgr.exe -add mellanox.cer -s -r localMachine root"; 
        retVal = _wsystem(bstrCmd);
        if(retVal == -1)
        {
            wprintf(L"Error in executing command: %s\n",bstrCmd);        
            return false;
        }
        
        bstrCmd =L"%SystemDrive%\\tmp\\certmgr.exe -add mellanox.cer -s -r localMachine trustedpublisher";
        retVal = _wsystem(bstrCmd);
        if(retVal == -1)
        {
            wprintf(L"Error in executing command: %s\n",bstrCmd);        
            return false;
        }            
    }
*/
    return true;
}

bool
CInstall::InstallMlnxCert()
{
    int retVal = _wsystem(L"\\\\10.4.0.102\\SWGWORK\\doront\\Winbuild.bat");
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: InstallMlnxCert\n");        
        return false;
    }

    return true;
}


