	
struct av_table_st{
	KSPIN_LOCK lock;
	void * table[1000];
	int size;
};

int assert_flag =0 ;

struct av_table_st table_av;

void av_table_init(){
	int i;
	for (i=0;i<1000;i++)
		table_av.table[i]  = 0;
	table_av.size = 0;
	KeInitializeSpinLock(&table_av.lock);
	return;
}

void av_table_insert(void * av){
	int i;
	KIRQL				irql;

	KeAcquireSpinLock(&table_av.lock, &irql);
	for (i=0;i<1000;i++){
		if(table_av.table[i] == 0 ){
			table_av.table[i]  = av;
			table_av.size++;
			KeReleaseSpinLock(&table_av.lock, irql);
			return;
		}
	}
	ASSERT(i != 1000);
	KeReleaseSpinLock(&table_av.lock, irql);
}

void av_table_remove(void *av){
	int i;
	KIRQL				irql;

	KeAcquireSpinLock(&table_av.lock, &irql);
	for (i=0;i<table_av.size;i++){
		if(table_av.table[i] == av ){
			table_av.table[i] = table_av.table[table_av.size-1];
			table_av.table[table_av.size-1] = 0;
			table_av.size--;
			KeReleaseSpinLock(&table_av.lock, irql);
			return;
		}
	}
	ASSERT(0);
	KeReleaseSpinLock(&table_av.lock, irql);
}


void av_table_lookup(void *av){
	int i;
	KIRQL				irql;

	KeAcquireSpinLock(&table_av.lock, &irql);
	for (i=0;i<table_av.size;i++){
		if(table_av.table[i] == av ){
			KeReleaseSpinLock(&table_av.lock, irql);
			return;
		}
	}
	ASSERT(assert_flag&& "av not fount in lookup ");
	KeReleaseSpinLock(&table_av.lock, irql);
}
	