// ==================================================================
// Used only for debuging of the RSS problem

class IndicateWatcher {
    bool m_Initstate;
    int m_CurrentProcessor;
    int m_CurrentHash;
    int m_LastSeenSeqnum;
    int m_BadPacketsCounter;

// Blocked thread data
    int m_BlockedThreadSeqnum;

    NDIS_SPIN_LOCK m_ObjectLock;
    NDIS_SPIN_LOCK m_WaitForSequanceLock;

public:
    void Indicating(PNDIS_PACKET* PacketArray, UINT PacketArrayCount);
    void Init() {
        m_Initstate = true;
        NdisAllocateSpinLock(&m_ObjectLock);
        NdisAllocateSpinLock(&m_WaitForSequanceLock);
    }
    
};


extern IndicateWatcher g_IndicateWatcher;


IndicateWatcher g_IndicateWatcher;

#if 0

// This is the code that was used to do the printing

void IndicateWatcher::Indicating(PNDIS_PACKET* PacketArray, UINT PacketArrayCount)
{

    UINT i;
    UINT found = 0;
    char *pBufferStart = NULL;
    if(m_Initstate) {
        // We are looking for 50 packets of the same type
        if (PacketArrayCount < 50) {
            return;
        }
        m_CurrentHash = NDIS_PACKET_GET_HASH_VALUE(PacketArray[0]);
        for(i=0; i < PacketArrayCount;i++) {
            if (m_CurrentHash == NDIS_PACKET_GET_HASH_VALUE(PacketArray[0])) {
                found++;
            }
        }

        if (found > 50) {
            // We have a winner
            m_Initstate = false;
            m_CurrentProcessor = KeGetCurrentProcessorNumber();
            ASSERT(m_CurrentHash == NDIS_PACKET_GET_HASH_VALUE(PacketArray[PacketArrayCount-1]));

            pBufferStart = (char *)
                (PacketArray[PacketArrayCount-1]->Private.Head->MappedSystemVa);

            IPHeader *pIp = (IPHeader *)(pBufferStart+14);

            TCPHeader *pTcp = (TCPHeader*)(pBufferStart+34);
            int tcp_seq = be32_to_cpu(pTcp->tcp_seq);
            m_LastSeenSeqnum = tcp_seq + be16_to_cpu(pIp->iph_length)-40;


            DbgPrint("a New connection was found processor id %d\n", m_CurrentProcessor);
            m_Initstate = false;
        }
        return;
        
    }

    // Let's look at the existing packets and see if there is a much

    if (m_CurrentProcessor != KeGetCurrentProcessorNumber()) {
        DbgPrint("We are called with another processor\n");
    }

    for(i=0; i < PacketArrayCount; i++) {
        if (m_CurrentHash != NDIS_PACKET_GET_HASH_VALUE(PacketArray[i])) {
            DbgPrint("An un-realted packet was found, skiping it\n");
            continue;
        }
        pBufferStart = (char *) (PacketArray[i]->Private.Head->MappedSystemVa);

        IPHeader *pIp = (IPHeader *)(pBufferStart+14);

        TCPHeader *pTcp = (TCPHeader*)(pBufferStart+34);
        if (pTcp->src_port != be16_to_cpu(2222)) {
            DbgPrint("A packet not related to our stream found, skipping it\n");
            continue;
        }


        
        if(m_LastSeenSeqnum == be32_to_cpu(pTcp->tcp_seq)) {
            // This packet is a good packet following the one before it
            m_LastSeenSeqnum += be16_to_cpu(pIp->iph_length) - 40;
            if (m_BadPacketsCounter !=0) {
                DbgPrint("Found a good packet after %d bad packets updating sequance to be %d\n",
                    m_BadPacketsCounter, m_LastSeenSeqnum);
            }            
        } else {
            if (m_BadPacketsCounter ==0) {
                DbgPrint("Start of out of sequance packets - last good one seen is %d\n", m_LastSeenSeqnum);
            }
            DbgPrint("Out of sequance packet, pid = %d, seqnum = %d\n", KeGetCurrentProcessorNumber(), be32_to_cpu(pTcp->tcp_seq));
            m_BadPacketsCounter++;
            
        }
    }

    if (m_BadPacketsCounter >= 1000) {
        m_Initstate = true;
        DbgPrint("Restarting the process\n");
        m_BadPacketsCounter = 0;
    }
}

#endif

void IndicateWatcher::Indicating(PNDIS_PACKET* PacketArray, UINT PacketArrayCount)
{

    UINT i;
    UINT found = 0;
    char *pBufferStart = NULL;
    if(m_Initstate) {
        // We are looking for 50 packets of the same type
        if (PacketArrayCount < 50) {
            return;
        }
        m_CurrentHash = NDIS_PACKET_GET_HASH_VALUE(PacketArray[0]);
        for(i=0; i < PacketArrayCount;i++) {
            if (m_CurrentHash == NDIS_PACKET_GET_HASH_VALUE(PacketArray[0])) {
                found++;
            }
        }

        if (found > 50) {
            // We have a winner
            m_CurrentProcessor = KeGetCurrentProcessorNumber();
            ASSERT(m_CurrentHash == NDIS_PACKET_GET_HASH_VALUE(PacketArray[PacketArrayCount-1]));

            pBufferStart = (char *)
                (PacketArray[PacketArrayCount-1]->Private.Head->MappedSystemVa);

            IPHeader *pIp = (IPHeader *)(pBufferStart+14);

            TCPHeader *pTcp = (TCPHeader*)(pBufferStart+34);
            int tcp_seq = be32_to_cpu(pTcp->tcp_seq);
            m_LastSeenSeqnum = tcp_seq + be16_to_cpu(pIp->iph_length)-40;


            DbgPrint("a New connection was found processor id %d start seqnum = %d\n", m_CurrentProcessor, m_LastSeenSeqnum);
            m_Initstate = false;
        }
        return;
        
    }

    // Let's look at the existing packets and see if there is a much

    NdisAcquireSpinLock(&m_ObjectLock);


    if (m_CurrentProcessor != KeGetCurrentProcessorNumber()) {
        DbgPrint("We are called with another processor\n");
    }

    for(i=0; i < PacketArrayCount; i++) {
        if (m_CurrentHash != NDIS_PACKET_GET_HASH_VALUE(PacketArray[i])) {
            DbgPrint("An un-realted packet was found, skiping it\n");
            continue;
        }
        pBufferStart = (char *) (PacketArray[i]->Private.Head->MappedSystemVa);

        IPHeader *pIp = (IPHeader *)(pBufferStart+14);

        TCPHeader *pTcp = (TCPHeader*)(pBufferStart+34);
        if (pTcp->src_port != be16_to_cpu(2222)) {
            DbgPrint("A packet not related to our stream found, skipping it\n");
            continue;
        }

        DbgPrint("Processing a packet with seq = %d\n", be32_to_cpu(pTcp->tcp_seq));
        
        if(m_LastSeenSeqnum == be32_to_cpu(pTcp->tcp_seq)) {
            // This packet is a good packet following the one before it
            m_LastSeenSeqnum += be16_to_cpu(pIp->iph_length) - 40;
            if (m_BlockedThreadSeqnum !=0) {
                DbgPrint("Found a good packet while someone is waiting updating sequance to be %d\n",
                    m_LastSeenSeqnum);
            }            
        } else {

            ASSERT(i==0);

            m_BlockedThreadSeqnum = be32_to_cpu(pTcp->tcp_seq);
            DbgPrint("Start of out of sequance packets => Waiting - last good one seen is %d , my seqnum %d\n", 
                m_LastSeenSeqnum, m_BlockedThreadSeqnum);

            NdisReleaseSpinLock(&m_ObjectLock);

            KIRQL CurrentLevel = KeRaiseIrqlToDpcLevel();
            NdisDprAcquireSpinLock(&m_WaitForSequanceLock);
            NdisDprAcquireSpinLock(&m_WaitForSequanceLock);
            NdisDprReleaseSpinLock(&m_WaitForSequanceLock);
            KeLowerIrql(CurrentLevel);

            NdisAcquireSpinLock(&m_ObjectLock);

            DbgPrint("Finally, I was released\n");

            ASSERT(m_LastSeenSeqnum == be32_to_cpu(pTcp->tcp_seq));
            m_LastSeenSeqnum += be16_to_cpu(pIp->iph_length) - 40;

            // We can now continue the loop as usual

#if 0
            if (m_BadPacketsCounter ==0) {
                DbgPrint("Start of out of sequance packets - last good one seen is %d\n", m_LastSeenSeqnum);
            }
            DbgPrint("Out of sequance packet, pid = %d, seqnum = %d\n", KeGetCurrentProcessorNumber(), be32_to_cpu(pTcp->tcp_seq));
            m_BadPacketsCounter++;
#endif            
        }
    }

#if 0
    if (m_BadPacketsCounter >= 1000) {
        m_Initstate = true;
        DbgPrint("Restarting the process\n");
        m_BadPacketsCounter = 0;
    }
#endif
    // We are about to quit
    if (m_BlockedThreadSeqnum == m_LastSeenSeqnum) {
        DbgPrint("Someone is locked, freeing it\n");
        NdisDprReleaseSpinLock(&m_WaitForSequanceLock);
        m_BlockedThreadSeqnum = 0;
    }
    NdisReleaseSpinLock(&m_ObjectLock);

}
