
#include <Winsock2.h>
#include <stdio.h>
#include <stdlib.h>
#include <mstcpip.h>
#include <ws2ipdef.h>



HANDLE g_hStdout;
CONSOLE_SCREEN_BUFFER_INFO g_ConsoleScreenBufferInfo;

#define ColorPrintf(Color, format) \
{ \
    SetConsoleTextAttribute(g_hStdout, Color); \
    printf format; \
    SetConsoleTextAttribute(g_hStdout, g_ConsoleScreenBufferInfo.wAttributes);\
}\


int AssertBreak() {
/*
    DebugBreak();
    return 1;
*/

    ColorPrintf(FOREGROUND_RED | FOREGROUND_INTENSITY, ("Assert has happened, program exiting") );
    
    exit(3);

}


__int64
GetTimeStamp( void )
{
	LARGE_INTEGER	tick_count, frequency;

	if( !QueryPerformanceFrequency( &frequency ) )
		return( 0 );

	if( !QueryPerformanceCounter( &tick_count ) )
		return( 0 );

	return( 1000000 * tick_count.QuadPart / frequency.QuadPart );
}


#undef ASSERT
#define ASSERT(expr) (void) ((expr) ||  AssertBreak())


#define GetTimeMs() (double)GetTimeStamp() / 1000


struct sockaddr addressFromString(char *address, int port)
{
    unsigned int b1,b2,b3,b4;

    struct sockaddr_in socket_address;
    struct sockaddr *socket_address_ptr = (struct sockaddr*)&socket_address;
    
    memset(&socket_address, 0, sizeof(socket_address));
    socket_address.sin_family = AF_INET;
    socket_address.sin_port = htons((u_short)port);


    sscanf(address, "%d.%d.%d.%d",&b1, &b2, &b3, &b4);
    socket_address.sin_addr.s_addr = b4 * 256 * 256 *256 +
                                     b3 * 256 * 256 + 
                                     b2 * 256 +
                                     b1;
                                     
    return *socket_address_ptr;
}



VOID IncreaseRecvSocketSize(SOCKET s, int RecvBufferSize)
{
    printf("Increasing socket size to %d\n", RecvBufferSize);
    int RealRecvBufferSize;
    int err = setsockopt(s, SOL_SOCKET, SO_RCVBUF,  (char *)&RecvBufferSize, sizeof (int));
    if ( err != 0 ) {
        ColorPrintf(FOREGROUND_RED | FOREGROUND_INTENSITY, ("Error setsockopt failed err=%d", WSAGetLastError()));
        goto cleanup;
    }
    int Size = sizeof (int);
    err = getsockopt(s, SOL_SOCKET, SO_RCVBUF,  (char *)&RealRecvBufferSize, &Size);
    if ( err != 0 ) {
        ColorPrintf(FOREGROUND_RED | FOREGROUND_INTENSITY, ("Error setsockopt failed err=%d", WSAGetLastError()));
        goto cleanup;
    }
    if (RealRecvBufferSize != RecvBufferSize) {
        ColorPrintf(FOREGROUND_RED | FOREGROUND_INTENSITY, ("Error: RealSendBufferSize = %d", RealRecvBufferSize));
    }
cleanup:    
    return;
}









const int MAX_QUEUE = 100000;

class SendPauser {

struct PausedPacket {
    unsigned char *      Packet;
    int                  PacketSize;
    __int64    Time;

};


public:
    VOID Init(char * server, int delay) {
        int rc;
        DWORD dw1 = 1;

        // Create the raw socket
        ss = socket(AF_INET, SOCK_RAW, IPPROTO_IP);
        if (ss == INVALID_SOCKET) 
        {
            printf("socket failed: %d\n", WSAGetLastError());
            goto Exit;
        }

        rc = setsockopt(ss, IPPROTO_IP, IP_HDRINCL, (char *)&dw1, sizeof dw1 );
        if (rc == SOCKET_ERROR)
        {
            fprintf(stderr, "setsockopt failed: %d\n", WSAGetLastError());
            goto Exit;
        }

        server_addr = addressFromString(server, 0);
        delayus = delay;

        
        Array = new PausedPacket[MAX_QUEUE];
        ASSERT(Array != NULL);
        ArraySize = 0;
Exit:
    return;
    }

    VOID AddPacket(unsigned char *Packet, int  PacketSize) {

        ASSERT(ArraySize < MAX_QUEUE);
        if (ArraySize >= MAX_QUEUE) {
            return;
        }
        Array[ArraySize].Packet = Packet;
        Array[ArraySize].Time = GetTimeStamp();
        Array[ArraySize].PacketSize = PacketSize;
        ArraySize++;
    }

    VOID TimerCB() {
        int i = 0;
        for (i=0; i < ArraySize; i++) {

            if(Array[i].Time + delayus < GetTimeStamp()) {
                int ret = sendto(ss, (char *)Array[i].Packet, Array[i].PacketSize, 0, &server_addr, sizeof(server_addr));
                delete []Array[i].Packet;
//              printf("sent %d bytes gle = %d\n", ret, WSAGetLastError());
            } else {
                break;
            }
        }
        if (i > 0) {
            MoveMemory(Array, Array + i, (ArraySize - i) * sizeof (PausedPacket));
            ArraySize -= i;
        }

    }

private:
    PausedPacket *Array;
    int ArraySize;
    SOCKET             ss;
    struct sockaddr server_addr;
    int delayus;

};

SendPauser g_SendPauser;


char PacketId[65536] = {0};


void usage(int argc, char *argv[])
{
   printf("This program will forward packets from one machine to another with a predefined delay\n");
   printf("usage:\n\t PacketHolder.exe  <local ip>, <remote ip>  <delay us>\n");
   printf("For example:\n\t PacketHolder.exe, 11.4.12.64 11.4.12.70 2000 \n");


}

int __cdecl main(int argc, char *argv[])
{
    int status, rc ;
    SOCKET             sr=INVALID_SOCKET;
    struct sockaddr_in my_addr;
    unsigned char *Buffer = NULL;


    if (argc != 4) {
        usage(argc, argv);
        return 1;
    }

    WSADATA wsaData;
    // Load Winsock
    if ((rc = WSAStartup(MAKEWORD(2,2), &wsaData)) != 0)
    {
        printf("WSAStartup() failed: %d\n", rc);
        status = -1;
        goto Exit;
    }

    g_SendPauser.Init(argv[2], atoi(argv[3]));


    // Create the raw socket
    sr = socket(AF_INET, SOCK_RAW, IPPROTO_IP);
    if (sr == INVALID_SOCKET) 
    {
        printf("socket failed: %d\n", WSAGetLastError());
        status = -1;
        goto Exit;
    }

    IncreaseRecvSocketSize(sr, 4096*1024);
    

    memset(&my_addr, 0, sizeof(my_addr));
    my_addr.sin_family = AF_INET;
    my_addr.sin_addr.s_addr = 64 * 256 * 256 *256 +
                                     12 * 256 * 256 + 
                                     4 * 256 +
                                     11;

    addressFromString(argv[1], 0);

    rc = bind(sr, (struct sockaddr*)&my_addr, sizeof (my_addr) );
    if (rc == SOCKET_ERROR)
    {
        fprintf(stderr, "bind failed: %d\n", WSAGetLastError());
        status = -1;
        goto Exit;
    }

    unsigned int opt = 1;
    DWORD bytes;
    if ((WSAIoctl(sr, SIO_RCVALL, &opt, sizeof(opt), NULL, 0, &bytes, NULL, NULL)) == SOCKET_ERROR) {
        fprintf(stderr, "WSAIoctl failed: %d\n", WSAGetLastError());
        status = -1;
        goto Exit;
    }

    struct sockaddr server_addr;
    server_addr = addressFromString("11.4.12.70", 0);

    DWORD dw1 = 1;


    rc = ioctlsocket(sr, FIONBIO, &dw1);
    if (rc == SOCKET_ERROR)
    {
        fprintf(stderr, "setsockopt failed: %d\n", WSAGetLastError());
        status = -1;
        goto Exit;
    }



    struct sockaddr_in recieved_addr;
    int recieved_addr_size = sizeof recieved_addr;
    
    while (1) {
        int ret = -1;
        DWORD gle = 10035;
        // recieve the data

        if (Buffer == NULL) {
            Buffer = new unsigned char[66000];
        }
        while (ret == -1 && gle ==10035) {
            ret = recvfrom(sr, (char *)Buffer, 66000, 0, (sockaddr *)&recieved_addr, &recieved_addr_size);
            gle = WSAGetLastError();
            g_SendPauser.TimerCB();
        }
#if 0
        printf("recieved %d bytes gle = %d packet was going to %d.%d.%d.%d (recv_from = %d.%d.%d.%d)\n", ret, gle, 
             Buffer[16],Buffer[17], Buffer[18], Buffer[19],
             recieved_addr.sin_addr.S_un.S_un_b.s_b1,
             recieved_addr.sin_addr.S_un.S_un_b.s_b2,
             recieved_addr.sin_addr.S_un.S_un_b.s_b3,
             recieved_addr.sin_addr.S_un.S_un_b.s_b4);
#endif
        if (ret ==-1) {
            printf("Error in recieve quiting gle =%d\n", gle);
            goto Exit;
        }
        USHORT PID =  Buffer[4] * 256 + Buffer[5];
        if (PacketId[PID] == 1) {
            PacketId[PID] = 0;
            continue;
        }
        PacketId[PID] = 1;

        g_SendPauser.AddPacket(Buffer, ret);
        Buffer = NULL;
        
    }



Exit:

    return 0;
}
