import _winreg
import sys
import subprocess
import time

def run_cmd(cmd):

    try:
        pipe = subprocess.Popen(cmd, False)
        rc = pipe.wait()
        if rc != 0:
            script_exit("Cmd '%s' failed, rc=%s" % (cmd, rc))
    except OSError, e:    
        script_exit("Cmd '%s' failed, error=%s" % (cmd, os.strerror(e.errno)))


def FindAdapterGuidByName(AdapterName):
    key = _winreg.OpenKey (_winreg.HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Network\\{4D36E972-E325-11CE-BFC1-08002BE10318}", 0, _winreg.KEY_READ)
    i = 0
    while True:
        try:
           AdapterKeyName = _winreg.EnumKey (key, i)
           AdapterKey = _winreg.OpenKey(key, AdapterKeyName,0 , _winreg.KEY_READ)
           try:
               Connection = _winreg.OpenKey(AdapterKey, "Connection",0 , _winreg.KEY_READ)
           except EnvironmentError:
               i += 1
               continue

           CurrentAdapterName , type = _winreg.QueryValueEx(Connection, "Name");
           if CurrentAdapterName == AdapterName:
              return AdapterKeyName
           i += 1
        except EnvironmentError:
           break

def FindAdapterByGuid (AdapterGuid):
    key = _winreg.OpenKey (_winreg.HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\class\\{4D36E972-E325-11CE-BFC1-08002BE10318}", 0, _winreg.KEY_READ)
    i = 0
    while True:
        try:
           AdapterKeyName = _winreg.EnumKey (key, i)
           AdapterKey = _winreg.OpenKey(key, AdapterKeyName,0 , _winreg.KEY_READ | _winreg.KEY_WRITE)
           try:
               NetCfgInstanceId , type = _winreg.QueryValueEx(AdapterKey, "NetCfgInstanceId");
               if AdapterGuid == NetCfgInstanceId:
                   return AdapterKey
           except EnvironmentError:
               pass
        except EnvironmentError:
           print "error"
           return
        i+= 1

def SetAdapterValue(AdapterKey, name, value):
    print "Setting " + name + "to " + value
    _winreg.SetValueEx(AdapterKey, name, 0, _winreg.REG_SZ, value)

def usage():
    print "Usage of program:"
    print sys.argv[0] + "<adapter name> <DefaultRecvRingProcessor> <TxInterruptProcessor> <TxForwardingProcessor>"
    print "example: " + sys.argv[0] + " \"Local Area Connection 6\" 1 2 3"



if __name__ == '__main__':
    if len(sys.argv) !=5:
        usage()
        sys.exit(1)

    DefaultRecvRingProcessor =  sys.argv[2]
    TxInterruptProcessor = sys.argv[3]
    TxForwardingProcessor = sys.argv[4]

    AdapterGuid = FindAdapterGuidByName(sys.argv[1])
    if AdapterGuid == None:
        print "Error (1) - wrong adapter name"
        usage()
        sys.exit(1)


    AdaptherKey = FindAdapterByGuid (AdapterGuid)
    if AdaptherKey == None:
        print "Error (2) - wrong adapter name"
        usage()
        sys.exit(1)


    SetAdapterValue(AdaptherKey , "DefaultRecvRingProcessor", sys.argv[2])
    SetAdapterValue(AdaptherKey , "TxInterruptProcessor", sys.argv[3])
    SetAdapterValue(AdaptherKey , "TxForwardingProcessor",sys.argv[4])

    run_cmd ("devman.exe disable pci\\ven_15B3*")
    run_cmd ("devman.exe enable pci\\ven_15B3*")

    time.sleep(6)

    run_cmd ("arp -s 1.1.2.1 00-d0-b0-10-42-00 1.1.2.48")
    run_cmd ("arp -s 1.1.1.1 00-d0-b0-10-41-00 1.1.1.48")


   
 

    print "Script has finished successfuly: Please don't forget to restart adapter before testing"
