import sys
import os
import shutil
import subprocess
import datetime

##################################
### run_cmd
################################## 
def run_cmd(cmd):

    try:
        pipe = subprocess.Popen(cmd, False)
        rc = pipe.wait()
        if rc != 0:
            script_exit("Cmd '%s' failed, rc=%s" % (cmd, rc))
    except OSError, e:    
        script_exit("Cmd '%s' failed, error=%s" % (cmd, os.strerror(e.errno)))


##################################
### get_down_val
################################## 
def get_down_val():

    try:
        pipe = subprocess.Popen("mcra mt26428_pci_cr0  0x10620",  stdout=subprocess.PIPE)
        rc = pipe.wait()
        if rc != 0:
            script_exit("Cmd '%s' failed, rc=%s" % (whoami, rc))
        val = pipe.stdout.readline()
        value = (int(val,16) & 0xffff) | (2 << 20);

    except OSError, e:    
        script_exit("Cmd '%s' failed, error=%s" % (cmd, os.strerror(e.errno)))
    return value


##################################
### get_device_name
################################## 
def get_device_name():

    try:
        pipe = subprocess.Popen("mst status",  stdout=subprocess.PIPE)
        rc = pipe.wait()
        if rc != 0:
            script_exit("Cmd '%s' failed, rc=%s" % (whoami, rc))
        val = pipe.stdout.readline()
        val = pipe.stdout.readline()
        val = pipe.stdout.readline()
        val = pipe.stdout.readline()

    except OSError, e:    
        script_exit("Cmd '%s' failed, error=%s" % (cmd, os.strerror(e.errno)))
    return val[0:-2]  #[0:17]



#####################
# The real program
####################

offset = "0x10620" # 0x10620 for port 1 0x10E20 for port 2

device = get_device_name()
value = get_down_val()
cmd = "mcra " + device+ " " +offset + " " + str(value)
print cmd
run_cmd (cmd)