import os
import platform
import subprocess
import sys
import string

##################################
### run_cmd
################################## 
def run_cmd(cmd):

    try:
        pipe = subprocess.Popen(cmd, False)
        rc = pipe.wait()
        if rc != 0:
            script_exit("Cmd '%s' failed, rc=%s" % (cmd, rc))
    except OSError, e:    
        script_exit("Cmd '%s' failed, error=%s" % (cmd, os.strerror(e.errno)))


###################
# script_exit
###################
def script_exit(err, exit_code=1):

    print err
    sys.exit(exit_code)


###################
# expand_path
###################
def expand_path(path):
    return string.replace (path, "\\", "\\\\")
  

##################
# is_64_bits_machine
##################
def is_64_bits_machine():

   path =os.getenv('windir') + "\\SysWOW64"
   return os.path.exists(path)


def get_build_location(last_stable):
    if is_64_bits_machine():
        os_type = "x64"
    else:
        os_type = "x86"

    print os_type
    infile = open(last_stable,"r")
    while infile:
        line = infile.readline()
        if line == "": break
        if line.find(os_type) >= 0 : return line

if platform.version()[0] == "6" :
    build_locatoin = get_build_location("m:\\projects\\wineth\\builds\\last_stable_wlh_chk.txt")
else:
    build_locatoin = get_build_location("m:\\projects\\wineth\\builds\\last_stable_wnet_chk.txt")

if build_locatoin[-1] == "\n":
    build_locatoin = build_locatoin[0:-1]

if is_64_bits_machine():
    cmd = "\\\\labfs01\\swgwork\\tzachid\\cmd64.exe"
else:
    cmd = "cmd"


command = cmd + " /c msiexec /quiet  /i " + build_locatoin
run_cmd(command)
