#include <windows.h>
#include <stdio.h>

    char command[10000]; 


int main( int argc, char *argv[] )
{
    STARTUPINFO si;
    PROCESS_INFORMATION pi;
    command[0] = '\0';
    ZeroMemory( &si, sizeof(si) );
    si.cb = sizeof(si);
    ZeroMemory( &pi, sizeof(pi) );

    if (argc < 2) {
        printf("Need to supply arguments\n");
        return 1;
    }
    for (int i=1; i < argc; i++) {
        strcat(command, argv[i]);
        strcat(command, " ");

    }

    // Start the child process. 
    if( !CreateProcess( NULL,   // No module name (use command line). 
        command, // Command line. 
        NULL,             // Process handle not inheritable. 
        NULL,             // Thread handle not inheritable. 
        FALSE,            // Set handle inheritance to FALSE. 
        0,                // No creation flags. 
        NULL,             // Use parent's environment block. 
        NULL,             // Use parent's starting directory. 
        &si,              // Pointer to STARTUPINFO structure.
        &pi )             // Pointer to PROCESS_INFORMATION structure.
    ) 
    {
        printf( "CreateProcess failed (%d).\n", GetLastError() );
        return 1;
    }

    // Wait until child process exits.
    WaitForSingleObject( pi.hProcess, INFINITE );


    FILETIME CreationTime;
    FILETIME ExitTime;
    FILETIME KernelTime;
    FILETIME UserTime;
    FILETIME Elappsed;


    BOOL ret = GetProcessTimes(pi.hProcess,& CreationTime, &ExitTime, &KernelTime,&UserTime);
    if(ret == 0) {
        printf("Error to get time");
        return 1;
    }

    ULARGE_INTEGER start = *(ULARGE_INTEGER *)&CreationTime;
    ULARGE_INTEGER end = *(ULARGE_INTEGER *)&ExitTime;

    end.QuadPart = end.QuadPart - start.QuadPart;
    Elappsed = *(FILETIME*)&end;
    
    SYSTEMTIME syElappsed, syUser, syKernel;
    ret = FileTimeToSystemTime( &Elappsed, &syElappsed);
    if(ret == 0) {
        printf("Error to get time");
        return 1;
    }
    ret = FileTimeToSystemTime( &UserTime, &syUser);
    if(ret == 0) {
        printf("Error to get time");
        return 1;
    }

    ret = FileTimeToSystemTime( &KernelTime, &syKernel);
    if(ret == 0) {
        printf("Error to get time");
        return 1;
    }

    printf("time %d.%d.%d:%d (user %d.%d.%d:%d  kernel %d.%d.%d:%d)", 
            syElappsed.wHour, syElappsed.wMinute,syElappsed.wSecond, syElappsed.wMilliseconds,
            syUser.wHour, syUser.wMinute,syUser.wSecond, syUser.wMilliseconds, 
            syKernel.wHour, syKernel.wMinute,syKernel.wSecond, syKernel.wMilliseconds  );


    // Close process and thread handles. 
    CloseHandle( pi.hProcess );
    CloseHandle( pi.hThread );
    return 0;
}
